package com.sxtvs.open.api.odata.controller;

import cn.hutool.core.util.IdUtil;
import com.sxtvs.open.api.odata.dto.wx.WxApiCreatePreAuthCodeResponse;
import com.sxtvs.open.api.odata.service.OauthService;
import com.sxtvs.open.core.auth.HttpContextUtil;
import com.sxtvs.open.core.auth.LoginRequired;
import com.sxtvs.open.core.conf.OauthConfig;
import com.sxtvs.open.core.sls.AliyunLogger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.servlet.ModelAndView;

import java.util.Map;

@Controller
@RequestMapping("oauth")
public class OauthController {


    @Autowired
    private OauthService oauthService;

    @Autowired
    private AliyunLogger logger;



    @RequestMapping("douyin/callback")
    public String douyinCallback(String code, String state) {
        var token = oauthService.loadStateMapping(state);
        logger.info("key", "oauth/douyin/callback", "code", code, "state", state, "token", token);
        // todo 用户数据入库
        return "redirect:https://www.baidu.com";
    }



    @RequestMapping("kuaishou/callback")
    public String kuaishouCallback(String code, String state) {
        var token = oauthService.loadStateMapping(state);
        logger.info("key", "oauth/kuaishou/callback", "code", code, "state", state, "token", token);
        // todo 用户数据入库
        return "redirect:https://www.baidu.com";
    }



    @RequestMapping("toutiao/callback")
    public String toutiaoCallback(String code, String state) {
        var token = oauthService.loadStateMapping(state);
        logger.info("key", "oauth/toutiao/callback", "code", code, "state", state, "token", token);
        // todo 用户数据入库
        return "redirect:https://www.baidu.com";
    }



    @RequestMapping("weibo/callback")
    public String weiboCallback(String code, String state) {
        logger.info("key", "oauth/weibo/callback", "code", code);
        // todo 用户数据入库
        return "redirect:https://www.baidu.com";
    }



    @RequestMapping("bilibili/callback")
    public String bilibiliCallback(String code, String state) {
        var token = oauthService.loadStateMapping(state);
        logger.info("key", "oauth/bilibili/callback", "code", code, "state", state, "token", token);
        // todo 用户数据入库
        return "redirect:https://www.baidu.com";
    }



    @RequestMapping("weixin/{appid}/callback")
    public String callback(
            @RequestParam("auth_code") String authCode,
            @RequestParam("expires_in") Integer expiresIn,
            @PathVariable("appid") String appid) {
        logger.info("key", "oauth/{appid}/callback", "data",
                Map.of("authCode", authCode, "expiresIn", expiresIn, "appid", appid));
        // todo 用户数据入库
        return "redirect:https://www.baidu.com";
    }
}
